package src;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Iterator;


// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.9289630B-97FF-01A0-6148-5C65EFEB78C2]
// </editor-fold> 
public class Jugador {

    private int tropasReserva = 0;
    private ArrayList<Dado> dadoAta;
    private ArrayList<Dado> dadoDef;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.C3251450-2ACF-9FDE-FD44-064F10A6DC9A]
    // </editor-fold> 
    private ArrayList<CartaTerritorio> cartaTerritorio;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.EB29420D-54E2-B10D-5245-11C691C85A54]
    // </editor-fold> 
    private CartaMision cartaMision;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.893C4933-EA65-FCEF-006E-9EAB7A84C0F7]
    // </editor-fold> 
    private ArrayList<Territorio> territoriosJug;//array que contiene los territorios que posee el jugador

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.C329B342-EB10-CE5B-11F2-2412EAF73E33]
    // </editor-fold> 
    //array que contiene los contienetes que posee el jugador, valido para ver los 
    //bonus de tropas que recibira el jugar en cada ronda
    private ArrayList<Continente> continenteJug;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.3545A043-7A94-1C04-9A6B-4208B60EB890]
    // </editor-fold> 
    private String nombreJugador;//nombre del jugador

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.8F51A544-89C6-951A-45C6-F1815BEDED91]
    // </editor-fold> 
    private int color;//color que defenira las tropas del jugador


    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.BE1AAF6B-AFB4-E588-49A8-D531F7DF5C24]
    // </editor-fold> 
    public Jugador(String nombre, int col) {
        setNombreJugador(nombre);
        setColor(col);
        territoriosJug = new ArrayList();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1AF8609D-0A28-F131-FA56-163684E7795F]
    // </editor-fold> 
    public int getColor() {
        return color;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E63EED10-2194-FC3A-3041-60646C96C17C]
    // </editor-fold> 
    public void setColor(int val) {
        color = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.F20D13F1-E7BE-555C-A366-C682CD6A9EC2]
    // </editor-fold> 
    public CartaMision getCartaMision() {
        return cartaMision;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.0115132D-0EDF-1CB5-0762-5C3D99A1F0BF]
    // </editor-fold> 
    public void setCartaMision(CartaMision val) {
        cartaMision = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.7512B379-52D7-60E6-CF9C-AB4348008272]
    // </editor-fold> 
    public ArrayList<CartaTerritorio> getCartaTerritorio() {
        return cartaTerritorio;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.25D56166-A9F5-713E-A010-FCF5A2A22255]
    // </editor-fold> 
    public void setCartaTerritorio(ArrayList<CartaTerritorio> val) {
        cartaTerritorio = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.005CB12A-15C1-A321-A429-A2128F358DD3]
    // </editor-fold> 
    public ArrayList<Continente> getContinente() {
        return continenteJug;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.D34124EF-B764-8739-D076-C99E40F3D767]
    // </editor-fold> 
    public void setContinente(ArrayList<Continente> val) {
        continenteJug = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1D450EB5-75B3-D41C-DDDB-4E7C51DF7372]
    // </editor-fold> 
    public ArrayList<Territorio> getTerritorio() {
        return territoriosJug;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.33DAD825-320C-3943-3957-F1A8A0BDB99E]
    // </editor-fold> 
    public void setTerritorio(ArrayList<Territorio> val) {
        territoriosJug = val;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.D5B98F11-8D73-533E-4682-AF96F2E155F5]
    // </editor-fold> 
    public String getNombreJugador() {
        return nombreJugador;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.CBEF3E8F-4EF4-5F7E-4823-AD96FAA9D959]
    // </editor-fold> 
    public void setNombreJugador(String val) {
        nombreJugador = val;
    }

    //metodo en el que el jugador visualiza el menu y escoge una las opciones
    public char jugarTurno() throws IOException {
        BufferedReader teclado = new BufferedReader(new InputStreamReader(System.in));
        String linea = null;

        char accion = 0;
        System.out.println();
        System.out.println("Qué deseas hacer?");
        System.out.println("   - Atacar (a)");
        System.out.println("   - Ver carta (v)");
        System.out.println("   - Terminar ataque y mover tropas (m)");
        System.out.println("   - Terminar turno (f)");
        System.out.println("   - Salir del juego (q)");
        System.out.print("Su opcion: ");

        linea = teclado.readLine();
        accion = linea.charAt(0);
        System.out.println();

        //comprobamos que ha pulsado una de las acciones correctas del menu
        if ((accion != 'a') && (accion != 'f') && (accion != 'q') && (accion != 'm') && (accion != 'v')) {
            System.out.println("Accion erronea. Pruebe de nuevo:");
            accion = jugarTurno();
        }

        return accion;
    }

    public void ubicarTropas() throws IOException {
        BufferedReader teclado = new BufferedReader(new InputStreamReader(System.in));
        String linea = null;

        //Mostramos los territorios del jugador y las tropas en ellos
        System.out.println(nombreJugador + ", seleccione el territorio donde ubicar:");
        for (int i = 0; i < territoriosJug.size(); i++) {
            System.out.println("  " + (i + 1) + " - " + territoriosJug.get(i).getNombreTerritorio() + " - Tropas: " + territoriosJug.get(i).getNumEjercito());
        }

        System.out.println("Tropas Restantes por ubicar: "+ tropasReserva);
        System.out.println();
        System.out.print("Su opcion: ");
        linea = teclado.readLine();

        //Convertimos el String a Int (Le restamos uno ya que anteriormente se 
        //lo mostramos a partir del 1 y no del 0)
        int numTerritorio = (Integer.parseInt(linea)) - 1;

        //Aqui realizar un while para comprobar que se ha introducido un valor correcto

        //VERSION PARA UBICAR MUCHAS TROPAS DE GOLPE

        /*//Ahora pedimos al usuario el numero de tropas a ubicar en el territorio seleccionado
        System.out.println("¿Cuantas tropas desea ubicar?");
        //Mostramos las tropas restantes por ubicar
        System.out.println("Numero de tropas restantes por ubicar: "+tropasReserva);
        
        linea = teclado.readLine();
        int numTropas = Integer.parseInt(linea);
        
        //Comprobamos que le numero de tropas es correcto
        while (numTropas > tropasReserva){
        System.out.println("Número incorrepto. Por favor, pruebe de nuevo.");
        System.out.println("¿Cuantas tropas desea ubicar?");
        System.out.println("Numero de tropas restantes por ubicar: "+tropasReserva);
        
        linea = teclado.readLine();
        numTropas = Integer.parseInt(linea);
        }
        
        //Añadimos las tropas al territorio y se la quitmaos de la reserva.
        territoriosJug.get(numTerritorio).setNumEjercito(numTropas+(territoriosJug.get(numTerritorio).getNumEjercito()));
        tropasReserva = tropasReserva-numTropas;
        System.out.println("¡Tropas ubicadas correctamente!");*/


        //VERSION PARA UBICAR TROPAS DE UNA EN UNA
        territoriosJug.get(numTerritorio).setNumEjercito(1 + (territoriosJug.get(numTerritorio).getNumEjercito()));
        tropasReserva--;
        
        
        System.out.println("¡Tropas ubicadas correctamente!");
    }

    public void moverTropas() throws IOException {
        BufferedReader teclado = new BufferedReader(new InputStreamReader(System.in));
        String linea = null;

        char accion = 0;
        //Variable que controla el numero de territorios que puede mover
        //para comunicarselo al jugador.
        int numterritorios = 0;

        System.out.println();
        System.out.println("---------------------");
        System.out.println();

        //Mientras no se pulse F o el usuario haya terminado de mover
        while (accion != 'f') {
            //Preguntamos al Jugador el territorio de origen y mostramos sus territorios.
            System.out.println("\tSeleccione el territorio origen:");
            for (int i = 0; i < territoriosJug.size(); i++) {
                //Solo mostramos los territorios con mas de 1 tropa
                if (territoriosJug.get(i).getNumEjercito() > 1) {
                    numterritorios++;
                    System.out.println("\t  " + (i + 1) + " - " + territoriosJug.get(i).getNombreTerritorio() + " - Tropas: " + territoriosJug.get(i).getNumEjercito());
                }
            }

            //Si no tiene ningun territorio con mas de 2 tropas
            //terminamos automaticamente la fase de mover.
            if (numterritorios == 0) {
                System.out.println("\t¡No tiene tropas disponibles para mover!");
                System.out.println();
                System.out.println("\tPulse Enter para continuar.");
                System.out.println();
                
                linea = teclado.readLine();
                accion = 'f';
            } else {
                System.out.println();
                System.out.println("\tTerminar turno (f)");
                System.out.println();
                System.out.print("Su opcion: ");

                linea = teclado.readLine();
                accion = linea.charAt(0);
            }

            //Aqui hay q comprobar que no ha introducido un valor no valido!!


            //Comprobamos que no se ha pulsado "f"
            while (accion != 'f') {
                //Convertimos el String a Int (Le restamos 1 ya que anteriormente se 
                //lo mostramos a partir del 1 y no del 0)
                int numTerritorio = (Integer.parseInt(linea)) - 1;

                //Mostramos los territorios adyacentes y de propiedad del jugador
                System.out.println("\tSeleccione el territorio destino:");
                for (int i = 0; i < territoriosJug.get(numTerritorio).getTerritoriosAdy().size(); i++) {
                    //Comprobamos mediante el Color del jugador si los territorios adyacentes son de el.
                    if (territoriosJug.get(numTerritorio).getPropietarioTer().getColor() == territoriosJug.get(numTerritorio).getTerritoriosAdy().get(i).getPropietarioTer().getColor()) {
                        System.out.println("\t  " + (i + 1) + " - " + territoriosJug.get(numTerritorio).getTerritoriosAdy().get(i).getNombreTerritorio() + " - Tropas: " + territoriosJug.get(numTerritorio).getTerritoriosAdy().get(i).getNumEjercito());
                    }
                }

                System.out.println();
                System.out.println("\tCancelar y terminar turno (f)");
                System.out.println();
                System.out.print("Su opcion: ");

                linea = teclado.readLine();
                accion = linea.charAt(0);


                //Aqui comprobar que no se ha introducido un valor no valido!!!

                while (accion != 'f') {
                    int terDestino = (Integer.parseInt(linea)) - 1;

                    //Pedimos el numero de tropas a mover
                    System.out.println("\t¿Cuantas tropas desea mover?");
                    System.out.println("\tTropas disponibles para mover: " + (territoriosJug.get(numTerritorio).getNumEjercito() - 1));

                    System.out.println();
                    System.out.println("\tCancelar y terminar turno (f)");
                    System.out.println();
                    System.out.print("Su opcion: ");

                    linea = teclado.readLine();
                    accion = linea.charAt(0);

                    while (accion != 'f') {
                        int numTropas = (Integer.parseInt(linea));

                        //Quitamos las tropas del territorio origen y se las sumamos al destino.
                        territoriosJug.get(numTerritorio).setNumEjercito(territoriosJug.get(numTerritorio).getNumEjercito() - numTropas);
                        territoriosJug.get(numTerritorio).getTerritoriosAdy().get(terDestino).setNumEjercito(territoriosJug.get(numTerritorio).getTerritoriosAdy().get(terDestino).getNumEjercito() + numTropas);
                        
                        accion = 'f';
                    }
                }
            }
        }
    }

    public void verCartas() {
        System.out.println("accion de ver carta aun no disponible");
    //Comprobamos además si puede cambiar cartas, y si puede le dejamos la opcion
    //de cambiar cartas
    }

    public void cambiarCartas() {
        System.out.println("accion de cambiar cartas aun no disponible");
    }

    public int getTropasReserva() {
        return tropasReserva;
    }

    public void setTropasReserva(int tropasReserva) {
        this.tropasReserva = tropasReserva;
    }

    public void atacar() throws IOException {
        BufferedReader teclado = new BufferedReader(new InputStreamReader(System.in));
        String linea = null;

        //selecionar los territorios origen del ataque
        System.out.println("\tSelecciona el territorio origen:");
        Iterator it = territoriosJug.iterator();
        int i = 1;
        while (it.hasNext()) {
            Territorio ter = (Territorio) it.next();
            System.out.println("\t" + i + " - " + ter.getNombreTerritorio());
            i++;
        }
        System.out.print("\tSu eleccion: ");
        linea = teclado.readLine();

        int terriseleccion = Integer.parseInt(linea);//pasamos la seleccion del usuario a int

        Territorio ataqueOrigen = territoriosJug.get(terriseleccion - 1);
        System.out.println(ataqueOrigen.getNombreTerritorio());


        //seleccionamos el destino del ataque
        ArrayList<Territorio> adyOrigen = ataqueOrigen.getTerritoriosAdy();
        Iterator it2 = adyOrigen.iterator();
        i = 1;
        System.out.println("\tSelecciona el territorio destino:");
        while (it2.hasNext()) {
            Territorio ter = (Territorio) it2.next();
            if (!nombreJugador.equalsIgnoreCase(ter.getPropietarioTer().getNombreJugador())) {
                System.out.println("\t" + i + " - " + ter.getNombreTerritorio());
            }
            i++;
        }
        System.out.print("\tSu eleccion: ");
        linea = teclado.readLine();
        terriseleccion = Integer.parseInt(linea);
        Territorio ataqueDestino = ataqueOrigen.getTerritoriosAdy().get(terriseleccion - 1);//territoriosJug.get(terriseleccion-1);

        //tenemos el origen y el destino del ataque, procedemos a atacar.
        atacar(ataqueOrigen, ataqueDestino);

    }

    public void atacar(Territorio origen, Territorio destino) throws IOException {
        int numDados;
        if (origen.getNumEjercito() == 1) {
            System.out.println("No puedes atacar");
        }
        BufferedReader teclado = new BufferedReader(new InputStreamReader(System.in));
        String linea = null;
        System.out.println("\t" + origen.getPropietarioTer().getNombreJugador() + " con cuantos dados desea atacar?");
        System.out.println("\t  1 - 1 Dado");
        System.out.println("\t  2 - 2 Dados");
        System.out.println("\t  3 - 3 Dados");
        System.out.print("\tAtacar con: ");

        linea = teclado.readLine();
        numDados = Integer.parseInt(linea);

        if (numDados < 1 || numDados > 3) {
            atacar(origen, destino);
        }

        //creamos el numero de dados que ha elegido
        setDadoAta((ArrayList<Dado>) new ArrayList());
        for (int i = 0; i < numDados; i++) {
            Dado d = new Dado('a');
            getDadoAta().add(d);
        }
        ordenaDados(dadoAta);

        System.out.println("\t" + destino.getPropietarioTer().getNombreJugador() + " con cuantos dados desea defenderte?");
        System.out.println("\t  1 - 1 Dado");
        System.out.println("\t  2 - 2 Dados");
        System.out.print("\tDefenderse con: ");

        linea = teclado.readLine();
        numDados = Integer.parseInt(linea);

        if (numDados < 1 || numDados > 2) {
            atacar();
        }

        //creamos el numero de dados que ha elegido
        setDadoDef((ArrayList<Dado>) new ArrayList());
        for (int i = 0; i < numDados; i++) {
            Dado d = new Dado('d');
            getDadoDef().add(d);
        }
        ordenaDados(dadoDef);
        compararDados(origen, destino, dadoAta, dadoDef);
    }
    
    private void compararDados(Territorio origen, Territorio destino, ArrayList<Dado> dadoAtac, ArrayList<Dado> dadoDef) {
        System.out.println(origen.getNombreTerritorio()+"  vs.  "+destino.getNombreTerritorio());
        for (int i = 0; i < dadoAtac.size(); i++) {
            if (i < dadoDef.size()) {
                if (dadoAtac.get(i).getValor() > dadoDef.get(i).getValor()) {
                    System.out.println("Dado " + (i + 1) + ": " + dadoAtac.get(i).getValor() + " - " + dadoDef.get(i).getValor() + ". Gana ataque");
                    destino.setNumEjercito(destino.getNumEjercito() - 1);
                } else {
                    if (dadoAtac.get(i).getValor() == dadoDef.get(i).getValor()) {
                        System.out.println("Dado " + (i + 1) + ": " + dadoAtac.get(i).getValor() + " - " + dadoDef.get(i).getValor() + ". Gana defensa");
                        origen.setNumEjercito(origen.getNumEjercito() - 1);
                    } else {
                        System.out.println("Dado " + (i + 1) + ": " + dadoAtac.get(i).getValor() + " - " + dadoDef.get(i).getValor() + ". Gana defensa");
                        origen.setNumEjercito(origen.getNumEjercito() - 1);
                    }
                }
            }
            else{
                System.out.println("Dado "+(i+1)+": "+dadoAtac.get(i).getValor());
            }
        }
    }

    private void ordenaDados(ArrayList<Dado> d){
        Dado aux;
        for (int i = 0; i < d.size(); i++) {
            for (int j = i; j < d.size(); j++) {
                if (d.get(i).getValor() < d.get(j).getValor()) {
                    aux = d.get(j);
                    d.set(j, d.get(i));
                    d.set(i, aux);
                }
            }
        }
    }

    public void setTerritorio(Territorio ter) {
        territoriosJug.add(ter);
    }

    public ArrayList<Dado> getDadoDef() {
        return dadoDef;
    }

    public void setDadoDef(ArrayList<Dado> dadoDef) {
        this.dadoDef = dadoDef;
    }

    public ArrayList<Dado> getDadoAta() {
        return dadoAta;
    }

    public void setDadoAta(ArrayList<Dado> dadoAta) {
        this.dadoAta = dadoAta;
    }
}

